// -*- C++ -*-

//=============================================================================
/**
 *  @file    analyzer.h
 *
 *  analyzer.h,v 1.3 2003/10/28 18:30:47 bala Exp
 *
 *  This file contains a DynAny analyzer that dumps the contents of a DynAny
 *  to the ace logging using ACE_DEBUG.
 *
 *  @author  Johnny Willemsen  (jwillemsen@remedy.nl)
 */
//=============================================================================

#ifndef ANALYZER_H
#define ANALYZER_H
#include "tao/DynamicAny/DynamicAny.h"
#include "tao/ORB.h"

// show_TC start

#include "ace/streams.h"
#include <list>		// list class library
using namespace std;

// show_TC end

class DynAnyAnalyzer
{
public:
  DynAnyAnalyzer(CORBA::ORB_ptr orb, DynamicAny::DynAnyFactory_ptr dynany_factory, int debug);

  void tab(int t);

  ~DynAnyAnalyzer();

  void resetTab();

  void analyze(DynamicAny::DynAny_ptr da ACE_ENV_ARG_DECL);

// show_TC begin

  void indent(int indent_lvl);

  void show_label(const CORBA::Any * ap);

  struct EqualTypeCodes {
            EqualTypeCodes(
                CORBA::TypeCode_ptr tc
            ): _ptr(tc) {}
    bool    operator()(CORBA::TypeCode_ptr rhs) const {
                return _ptr->equal(rhs);
            }
    CORBA::TypeCode_ptr _ptr;
  };

  void show_TC(
    CORBA::TypeCode_ptr         tcp,
    list<CORBA::TypeCode_var> & tlist,
    int                         indent_lvl);


  void show_TC(CORBA::TypeCode_ptr tcp);

//  const int INDENT = 4;

// show_TC end 

private:
  CORBA::ORB_var orb_;
  DynamicAny::DynAnyFactory_var dynany_factory_;
  int level_;
  int debug_;
  int INDENT;

};


#endif // ANALYZER_H
